//+------------------------------------------------------------------+
//|                                           Price Channel Diff.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
 
#property link      "Bill Burns"

#property indicator_separate_window
#property indicator_buffers    1
#property indicator_color1     Blue
#property indicator_levelcolor Khaki

//
//
//
//
//

extern int    ChannelPeriod   = 14;
extern int    ShiftValue      = 1;
extern double Level           = 0.0025;  
extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern bool   alertsNotify    = false;
extern string soundFile       = "alert2.wav";  

//
//
//
//
//

double DiffBuffer[];
double trend[];

//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,DiffBuffer); SetIndexShift(0,ShiftValue); SetIndexLabel(0,"Difference");
   SetIndexBuffer(1,trend);
   SetLevelValue(0,Level);
   IndicatorShortName("Channel Difference("+ChannelPeriod+")");
return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,k,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1); 

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
       
       double thi    = High[i];
       double tlo    = Low[i];
       double tprice = 0;
       if (i >= Bars - ChannelPeriod) continue;
       for(k = 0; k < ChannelPeriod; k++)
       {
           tprice = High[i+k];
           if(thi < tprice)  thi = tprice;
         
           tprice = Low[i+k];
           if(tlo  > tprice) tlo = tprice;
       }
       
       if ((thi+tlo) > 0.0) 
            DiffBuffer[i] = NormalizeDouble(thi,Digits) - NormalizeDouble(tlo,Digits); 
       else DiffBuffer[i] = 0;
       
       //
       //
       //
       //
       //
       
       trend[i] = trend[i+1];
       if (DiffBuffer[i]>Level) trend[i] = 1; 
       if (DiffBuffer[i]<Level) trend[i] =-1;
   }
     
   //
   //
   //
   //
   //
      
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("crossed Level up");
      else  doAlert("crossed Level down");       
   } 
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Price_Channel_Diff ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Price_Channel_Diff "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}


   